<template>
  <div class="app-container">
    <el-row :gutter="10" class="mb8">
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>
    <el-table v-loading="loading" :span-method="mergeMethod" :data="dsdtList" :height="clientHeight"
              @selection-change="handleSelectionChange"
              border>
      <el-table-column type="selection" width="55" align="center" fixed="left"/>
      <el-table-column label="详细计划" align="center" prop="detailPlan" :show-overflow-tooltip="true" width="180"
                       fixed="left"/>
      <el-table-column label="计划培训开始时间" prop="planDate" width="180" align="center" fixed="left">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.planDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="培训主题" align="center" prop="topic" :show-overflow-tooltip="true" fixed="left"
                       width="180"/>
      <!--      <el-table-column label="培训计划" align="center" prop="courseDay" :show-overflow-tooltip="true" width="180"/>-->
      <el-table-column label="培训内容" align="center" prop="content" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="培训状态" align="center" prop="planStatus" :show-overflow-tooltip="true" width="180">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.planStatus == 2" size="small" type="warning">待考试</el-tag>
          <el-tag v-if="scope.row.planStatus == 3" size="small" type="success">已完成</el-tag>
          <el-tag v-if="scope.row.planStatus == 1" size="small" type="danger">已中止</el-tag>
          <el-tag v-else-if="scope.row.planStatus == 0" size="small" type="info">未完成</el-tag>
          <el-tag v-else-if="scope.row.planStatus == 4" size="small" type="danger">已中止待审批</el-tag>
          <el-tag v-else-if="scope.row.planStatus == 5" size="small" type="success">已完成待审批</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="第一次成绩" align="center" prop="score1" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="附件" align="center" :show-overflow-tooltip="true" width="80">
        <template slot-scope="scope">
          <el-button icon="el-icon-folder" style="color:#6e96fa;" @click="handleDoc(scope.row , 'tsNew-score1')"
                     circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="第二次成绩" align="center" prop="score2" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="附件" align="center" :show-overflow-tooltip="true" width="80">
        <template slot-scope="scope">
          <el-button icon="el-icon-folder" style="color:#6e96fa;" @click="handleDoc(scope.row , 'tsNew-score2')"
                     circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="第三次成绩" align="center" prop="score3" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="附件" align="center" :show-overflow-tooltip="true" width="80">
        <template slot-scope="scope">
          <el-button icon="el-icon-folder" style="color:#6e96fa;" @click="handleDoc(scope.row , 'tsNew-score3')"
                     circle></el-button>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remarks" :show-overflow-tooltip="true" width="180"/>
      <el-table-column label="操作" align="center" fixed="right" width="230" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-folder"
            @click="openFileDialog(scope.row)"
          >学习资料
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <el-dialog :close-on-click-modal="false" :visible.sync="file.open" width="30%" append-to-body>
      <el-descriptions class="margin-top" title="学习资料" :column="1" size="medium" border>
        <el-descriptions-item label-style="width:180px">
          <template slot="label">
            <i class="el-icon-user"></i>
            资料名
          </template>
          {{ file.data.fileName }}
        </el-descriptions-item>
        <el-descriptions-item label-style="width:180px">
          <template slot="label">
            <i class="el-icon-mobile-phone"></i>
            学习进度
          </template>
          <el-progress :text-inside="true" :stroke-width="20" :percentage="getCountTime()"
                       status="success"></el-progress>
        </el-descriptions-item>
        <el-descriptions-item label-style="width:180px">
          <template slot="label">
            <i class="el-icon-mobile-phone"></i>
            应学习时长（分）
          </template>
          {{ file.data.timerNeed }}
        </el-descriptions-item>
        <el-descriptions-item label-style="width:180px">
          <template slot="label">
            <i class="el-icon-mobile-phone"></i>
            已学习时长（分）
          </template>
          {{ learnTime }}
        </el-descriptions-item>
      </el-descriptions>
      <el-button
        class="mt10"
        type="primary"
        icon="el-icon-video-play"
        @click="handleStudy(file.data)"
      >开始学习
      </el-button>
    </el-dialog>

    <el-dialog :close-on-click-modal="false" element-loading-background="rgba(0,0,0,0.2)"
               v-dialogDrag :title="pdf.title"
               :visible.sync="pdf.open" width="1300px" height="800px" :center="true" append-to-body
               @close="handleClose">
      <div style="margin-top: -60px;float: right;margin-right: 40px;">
        <br/>累计学习时长：{{ learnTime == null ? "0" : learnTime }} min
      </div>
      <div style="margin-top: -30px">
        <iframe id="iFrame" class="iframe-html" :src="pdf.pdfUrl" frameborder="0" width="100%" height="700px"
                v-if="ppt"></iframe>
      </div>
    </el-dialog>


    <!-- 报告附件对话框 -->
    <el-dialog :close-on-click-modal="false" v-dialogDrag :title="doc.title" :visible.sync="doc.open" width="1000px"
               append-to-body>
      <el-table :data="doc.commonfileList" border>
        <el-table-column :label="$t('文件名')" align="center" prop="fileName" :show-overflow-tooltip="true">
          <template slot-scope="scope">
            <a class="link-type" @click="handleDownload(scope.row)">
              <span>{{ scope.row.fileName }}</span>
            </a>
          </template>
        </el-table-column>
        <el-table-column :label="$t('大小(Kb)')" align="center" prop="fileSize" :show-overflow-tooltip="true"
                         width="80"/>
        <el-table-column :label="$t('上传人')" align="center" prop="creator" :show-overflow-tooltip="true" width="120"/>
        <el-table-column :label="$t('上传日期')" align="center" prop="createdate" :show-overflow-tooltip="true"
                         width="120">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.createdate, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
      </el-table>
      <el-dialog :close-on-click-modal="false" v-dialogDrag :title="pdf.title" :visible.sync="pdf.open" width="1300px"
                 append-to-body>
        <div style="margin-top: -60px;float: right;margin-right: 40px;">
          <el-button size="mini" type="text" @click="openPdf">{{ $t('新页面打开PDF') }}</el-button>
        </div>
        <div style="margin-top: -30px">
          <iframe :src="pdf.pdfUrl" frameborder="0" width="100%" height="700px"></iframe>
        </div>
      </el-dialog>

      <div slot="footer" class="dialog-footer">
        <!--        <el-button type="primary" @click="submitFileForm">{{ $t('确 定') }}</el-button>-->
        <el-button @click="doc.open = false">{{ $t('返 回') }}</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  addLjplandsdt,
  delLjplandsdt,
  getLjplandsdt,
  listLjplandsdt,
  updateLjLearnTime,
  updateLjplandsdt
} from "@/api/training/bccnew/ljplandsdt";
import {
  addYsplandsdt,
  delYsplandsdt,
  getYsplandsdt,
  listYsplandsdt,
  updateYsLearnTime,
  updateYsplandsdt
} from "@/api/training/bccnew/ysplandsdt";
import {
  addFlplandsdt,
  delFlplandsdt,
  getFlplandsdt,
  listFlplandsdt,
  updateFlLearnTime,
  updateFlplandsdt
} from "@/api/training/bccnew/flplandsdt";
import {
  addFtplandsdt,
  delFtplandsdt,
  getFtplandsdt,
  listFtplandsdt,
  updateFtLearnTime,
  updateFtplandsdt
} from "@/api/training/bccnew/ftplandsdt";
import {treeselect} from "@/api/system/dept";
import Treeselect from "@riophae/vue-treeselect";
import {getToken} from "@/utils/auth";
import {allFileList, delCommonfile} from "@/api/common/commonfile";

var timer = null;
export default {
  name: "score_s",
  props: {
    newId: {},
    planType: {}
  },
  components: {Treeselect},
  data() {
    return {
      // 报告附件参数
      doc: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "附件",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 报告附件上传位置编号
        ids: 0,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/common/commonfile/uploadFile",
        commonfileList: null,
        queryParams: {
          pId: null,
          pType: 'traning'
        },
        pType: 'traning',
        pId: null,
        form: {}
      },
      file: {
        open: false,
        data: {}
      },
      ppt: false,
      learnTime: null,
      pdf: {
        title: '',
        pdfUrl: '',
        numPages: null,
        open: false,
        pageNum: 1,
        pageTotalNum: 1,
        loadedRatio: 0,
        loadingFlash: false,
      },
      // 选中数组
      ids: [],
      // 总条数
      total: 0,
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      loading: true,
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      // 培训状态字典
      planStatusOptions: [],
      clientHeight: 300,
      // 是否显示弹出层
      open: false,
      dsdtList: [],
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        newId: this.newId
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {}
    }
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    }
  },
  created() {
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 250
    })
    this.getList();
    this.getTreeselect();
    this.getDicts("training_bccnew_status").then(response => {
      this.planStatusOptions = response.data;
    });
  },
  methods: {
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", {dangerouslyUseHTMLString: true});
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    /** 报告附件按钮操作 */
    handleDoc(row, fileType) {
      if (this.planType === 1) {
        fileType += 'lj';
      } else if (this.planType === 2) {
        fileType += 'ys';
      } else if (this.planType === 3) {
        fileType += 'fl';
      } else if (this.planType === 4) {
        fileType += 'ft';
      }
      this.doc.pType = fileType
      this.doc.queryParams.pType = fileType
      this.doc.id = row.id;
      this.doc.title = this.$t('附件');
      this.doc.open = true;
      this.doc.queryParams.pId = row.id
      this.doc.pId = row.id
      this.getFileList()
      this.$nextTick(() => {
        this.$refs.doc.clearFiles()
      })
    },
    getFileList() {
      allFileList(this.doc.queryParams).then(response => {
        response.forEach(element => {
          element["isEdit"] = false
        });
        response.forEach(element => {
          element["isAdd"] = false
        });
        this.doc.commonfileList = response;
      });
    },
    //附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
      this.doc.isUploading = true;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      this.doc.isUploading = false;
      this.$alert(response.msg, this.$t('导入结果'), {dangerouslyUseHTMLString: true});
      this.getFileList()
    },
    // 文件下载处理
    handleDownload(row) {
      var name = row.fileName;
      var url = row.fileUrl;
      var suffix = url.substring(url.lastIndexOf("."), url.length);
      const a = document.createElement('a')
      a.setAttribute('download', name)
      a.setAttribute('target', '_blank')
      a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
      a.click()
    },
    openPdf() {
      window.open(this.pdf.pdfUrl);//path是文件的全路径地址
    },
    handleSee(row) {
      // window.open(process.env.VUE_APP_BASE_API +'/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl);//path是文件的全路径地址
      this.pdf.open = true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + '/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl
    },
    /** 删除按钮操作 */
    handleDeleteDoc(row) {
      const ids = row.id || this.ids;
      this.$confirm(this.$t('是否确认删除?'), this.$t('警告'), {
        confirmButtonText: this.$t('确定'),
        cancelButtonText: this.$t('取消'),
        type: "warning"
      }).then(function () {
        return delCommonfile(ids);
      }).then(() => {
        this.getFileList()
        this.msgSuccess(this.$t('删除成功'));
      })
    },
    handleClose() {
      window.clearInterval(timer);
      this.getList();
    },
    handleStudy(row) {
      //office预览
      this.pdf.open = true
      this.pdf.title = row.fileName
      this.pdf.pdfUrl = ""
      this.ppt = true
      //如果是PDF等直接可以打开的就不调接口，否则调用接口
      if (row.fileName != null && row.fileName.endsWith('pdf')) {
        this.pdf.pdfUrl = process.env.VUE_APP_BASE_API + '/pdf/web/viewer.html?file=' + process.env.VUE_APP_BASE_API + row.fileUrl

      }
      this.learnTime = row.timer;
      let _this = this;
      if (this.planType === 1) {
        timer = window.setInterval(function () {
          updateLjLearnTime(row).then(res => {
            _this.file.data.timer = res.data
            _this.learnTime = res.data;
            row.timer = res.data;
          })
        }, 60000);
      } else if (this.planType === 2) {
        timer = window.setInterval(function () {
          updateYsLearnTime(row).then(res => {
            _this.file.data.timer = res.data
            _this.learnTime = res.data;
            row.timer = res.data;
          })
        }, 60000);
      } else if (this.planType === 3) {
        timer = window.setInterval(function () {
          updateFlLearnTime(row).then(res => {
            _this.file.data.timer = res.data
            _this.learnTime = res.data;
            row.timer = res.data;
          })
        }, 60000);
      } else if (this.planType === 4) {
        timer = window.setInterval(function () {
          updateFtLearnTime(row).then(res => {
            _this.file.data.timer = res.data
            _this.learnTime = res.data;
            row.timer = res.data;
          })
        }, 60000);
      }
    },
    getCountTime() {
      if (this.file.data.timerNeed === 0)
        return 0;
      return parseInt((this.learnTime / this.file.data.timerNeed * 100).toFixed(2))
    },
    openFileDialog(row) {
      let num = 1;
      for (let i = 0; i < this.dsdtList.length; i++) {
        if (i === 0) {
          continue;
        }
        let item = this.dsdtList[i];
        if (item.id === row.id) {
          if (row.id !== this.dsdtList[i - 1].id) {
            if (this.dsdtList[i - 1].planStatus !== 5 && this.dsdtList[i - 1].planStatus !== 3 && this.dsdtList[i - 1].planStatus !== 1) {
              this.$alert('您必须完成上一项考试才可学习当前资料！', "注意", {dangerouslyUseHTMLString: true});
              return;
            }
          } else {
            num++;
          }
        }
      }
      this.file.open = true;
      this.file.data = row
      this.learnTime = row.timer;
      if (row.timer === '' || row.timer == null) {
        this.learnTime = 0;
      }
      if (row.timerNeed === '' || row.timerNeed == null) {
        this.file.data.timerNeed = 0
      }
    },
    getList() {
      if (this.planType == 1) {
        listLjplandsdt(this.queryParams).then(res => {
          this.dsdtList = res.data;
          this.total = 0;
          this.loading = false;
        })
      } else if (this.planType == 2) {
        listYsplandsdt(this.queryParams).then(res => {
          this.dsdtList = res.data;
          this.total = 0;
          this.loading = false;
        })
      } else if (this.planType == 3) {
        listFlplandsdt(this.queryParams).then(res => {
          this.dsdtList = res.data;
          this.total = 0;
          this.loading = false;
        })
      } else if (this.planType == 4) {
        listFtplandsdt(this.queryParams).then(res => {
          this.dsdtList = res.data;
          this.total = 0;
          this.loading = false;
        })
      }
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        newId: this.newId,
        courseCode: null,
        topic: null,
        content: null,
        courseDay: null,
        courseHour: null,
        detailPlan: null,
        trainer: null,
        courseDate: null,
        assess: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        remarks: null,
        planStatus: 0,
        score1: null,
        score2: null,
        score3: null
      };
      this.resetForm("form");
    }, /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    handleDelete(row) {
      const ids = row.id || this.ids;
      if (this.planType == 1) {
        this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function () {
          return delLjplandsdt(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
      } else if (this.planType == 2) {
        this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function () {
          return delYsplandsdt(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
      } else if (this.planType == 3) {
        this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function () {
          return delFlplandsdt(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
      } else if (this.planType == 4) {
        this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function () {
          return delFtplandsdt(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
      }
    },
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      if (this.planType == 1) {
        getLjplandsdt(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改课程";
        });
      } else if (this.planType == 2) {
        getYsplandsdt(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改课程";
        });
      } else if (this.planType == 3) {
        getFlplandsdt(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改课程";
        });
      } else if (this.planType == 4) {
        getFtplandsdt(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改课程";
        });
      }
    },
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加课程";
    }, /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            if (this.planType == 1) {
              updateLjplandsdt(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else if (this.planType == 2) {
              updateYsplandsdt(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else if (this.planType == 3) {
              updateFlplandsdt(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else if (this.planType == 4) {
              updateFtplandsdt(this.form).then(response => {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            }
          } else {
            if (this.planType == 1) {
              addLjplandsdt(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            } else if (this.planType == 2) {
              addYsplandsdt(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            } else if (this.planType == 3) {
              addFlplandsdt(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            } else if (this.planType == 4) {
              addFtplandsdt(this.form).then(response => {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        }
      });
    },
    //合并单元格
    mergeMethod({row, column, rowIndex, columnIndex}) {
      // console.log(row)
      if ([1, 3, 5, 6, 7, 8, 9, 10, 11, 12, 13].includes(columnIndex)) {
        const _row = this.setTable(this.dsdtList).merge[rowIndex];
        const _col = _row > 0 ? 1 : 0;
        return {
          rowspan: _row,
          colspan: _col
        };
      }
    },
    //单元格整理
    setTable(tableData) {
      //    console.log(tableData)
      let spanArr = [],
        concat = 0;
      tableData.forEach((item, index) => {
        if (index === 0) {
          spanArr.push(1);
        } else {
          if (item.id === tableData[index - 1].id) {
            //第一列需合并相同内容的判断条件
            spanArr[concat] += 1;
            spanArr.push(0);
          } else {
            spanArr.push(1);
            concat = index;
          }
        }
      });
      return {
        merge: spanArr
      };
    },
  }
};


</script>

<style scoped>

</style>
